//#define NDEBUG
#include <cassert>
#include "Estudiant.hh"


Estudiant::Estudiant() {
  dni=0;
  amb_nota = false;
}


Estudiant::Estudiant(int d) {
  assert(d > 0 and "DNI incorrecte");
  
  dni = d;
  amb_nota = false;
}


Estudiant::Estudiant(const Estudiant& e1) {
  dni = e1.dni; 
  amb_nota = e1.amb_nota; 
  if (amb_nota) nota = e1.nota;
}


void Estudiant::afegir_nota(double n) {
  assert(not amb_nota and "Ja te nota");
  assert(0 <= n and n <= MAX_NOTA and "n entre 0 a 10");
  
  nota = n; 
  amb_nota = true;
}


void Estudiant::modificar_nota(double nota) { 				
  assert(amb_nota and "No te nota");
  assert(0 <= nota and nota <= MAX_NOTA and "n entre 0 a 10");
  
  this->nota = nota;
}

bool Estudiant::te_nota() const {
  return amb_nota;
}


double Estudiant::consultar_nota() const {

  assert(amb_nota and "No te nota");
  return nota;
}


int Estudiant::consultar_DNI() const {
  return dni;
}

double Estudiant::nota_maxima() {
  return MAX_NOTA;
}

bool Estudiant::menor_dni(const Estudiant& e1, const Estudiant& e2) {
  return e1.dni < e2.dni; 
}

void Estudiant::llegir() {
  cin >> dni;
  
  assert(dni > 0 and "DNI incorrecte");
  
  double x;
  cin >> x;
  if (x >= 0 and x <= MAX_NOTA) {
    nota = x; 
    amb_nota = true;
  }
  else amb_nota = false;
}


void Estudiant::escriure() const {
  if (amb_nota)
    cout << dni << " " << nota << endl;
  else
    cout << dni <<" NP" << endl;
}
